/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.tm.core;

import junit.framework.TestCase;
import benten.cat.tm.engine.omegat.DefaultTmDriver;

public class BentenTmDriverManagerTest extends TestCase {

	public static class TestTmDriver implements BentenTmDriver {
		public static final String DRIVER_NAME = "test";

		static {
			// 自分を登録。
			BentenTmDriverManager.registerDriver(new TestTmDriver());
		}

		public String getName() {
			return DRIVER_NAME;
		}
		public BentenTmEngine getEngineInstance() {
			return null;
		}
	}

	public void testRegisterDriver() {
		try {
			BentenTmDriverManager.registerDriver(null);
			fail();
		} catch (final IllegalArgumentException e) {
			assertTrue(true);
		}
		try {
			BentenTmDriverManager.getDriver(null);
			fail();
		} catch (final IllegalArgumentException e) {
			assertTrue(true);
		}
		assertNull(BentenTmDriverManager.getDriver("regex"));
		try {
			BentenTmDriverManager.deregisterDriver(null);
			fail();
		} catch (final IllegalArgumentException e) {
			assertTrue(true);
		}
		assertEquals(0, BentenTmDriverManager.getDrivers().length);
		new DefaultTmDriver();
		assertEquals(1, BentenTmDriverManager.getDrivers().length);
		new DefaultTmDriver();
		assertEquals(1, BentenTmDriverManager.getDrivers().length);
		new TestTmDriver();
		assertNotNull(BentenTmDriverManager.getDriver("test"));
		assertEquals(2, BentenTmDriverManager.getDrivers().length);
		BentenTmDriverManager.deregisterDriver(new TestTmDriver());
		assertEquals(1, BentenTmDriverManager.getDrivers().length);
		BentenTmDriverManager.deregisterDriver(new TestTmDriver());
		assertEquals(1, BentenTmDriverManager.getDrivers().length);
		BentenTmDriverManager.deregisterDriver(new DefaultTmDriver());
		assertEquals(0, BentenTmDriverManager.getDrivers().length);
		BentenTmDriverManager.deregisterDriver(new DefaultTmDriver());
		assertEquals(0, BentenTmDriverManager.getDrivers().length);
	}
}
